var binTree = require( './binTree');

var assert = require('assert');

describe('size', function() {
  it(' für leere Menge ', function() {
    assert.equal(binTree.BinTree.empty().size(), 0);
  });
});

describe('size', function() {
  it(' für  Menge 1', function() {
    var t = binTree.BinTree.empty();
    t.add(42);
    t.add(42);
    t.add(32);
    t.add(52);
    t.add(47);
    t.add(47);
    t.add(37);
    t.add(40);
    assert.equal(t.size(), 6);
  });
});

describe('contains', function() {
  it(' für leere Menge ', function() {
    assert.equal(binTree.BinTree.empty().contains(42), false);
  });
});


describe('contains', function() {
  it(' für  Menge 1', function() {
    var t = binTree.BinTree.empty();
    t.add(42);
    t.add(42);
    t.add(32);
    t.add(52);
    t.add(47);
    t.add(47);
    t.add(37);
    t.add(40);
    assert.equal(t.contains(42), true);
    assert.equal(t.contains(40), true);
    assert.equal(t.contains(47), true);
    assert.equal(t.contains(17), false);
  });
});

describe('toArray', function() {
  it(' für  Menge 1', function() {
    var rs = [];
    var t = binTree.BinTree.empty();
    t.add(42);
    t.add(42);
    t.add(32);
    t.add(52);
    t.add(47);
    t.add(47);
    t.add(37);
    t.add(40);

    t.toArray(rs);
    assert.deepEqual(rs, [32,37,40,42,47,52]);
  });
});

describe('toArray', function() {
  it(' für  Menge 2', function() {
    var rs = [];
    var t = binTree.BinTree.empty();
    t.add("das");
    t.add("pferd");
    t.add("frisst");
    t.add("keinen");
    t.add("gurkensalat");

    t.toArray(rs);
    assert.deepEqual(rs, ['das', 'frisst', 'gurkensalat', 'keinen', 'pferd']);
  });
});
